#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_DiamondPurchaseCFG.h"
std::auto_ptr<M_DiamondPurchaseCFG> M_DiamondPurchaseCFG::msSingleton(nullptr);

int M_DiamondPurchaseCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_DiamondPurchaseCFGData* M_DiamondPurchaseCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_DiamondPurchaseCFGData>& M_DiamondPurchaseCFG::GetMapData()
{
	return mMapData;
}

void M_DiamondPurchaseCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_DiamondPurchaseCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_DiamondPurchaseCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mDiamondType = element->IntAttribute("DiamondType");
		data.mTask = element->Attribute("Task");
		data.mLastTime = element->IntAttribute("LastTime");
		data.mOriginalprice = element->IntAttribute("Originalprice");
		data.mPurchasePrice = element->IntAttribute("PurchasePrice");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mCount = element->IntAttribute("Count");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_DiamondPurchaseCFG Loaded. Load Data:%u", mMapData.size());
}

void M_DiamondPurchaseCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_DiamondPurchaseCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_DiamondPurchaseCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_DiamondPurchaseCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readInt(L, "DiamondType", data.mDiamondType);
		LuaCfgHelper::readString(L, "Task", data.mTask);
		LuaCfgHelper::readInt(L, "LastTime", data.mLastTime);
		LuaCfgHelper::readInt(L, "Originalprice", data.mOriginalprice);
		LuaCfgHelper::readInt(L, "PurchasePrice", data.mPurchasePrice);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "Count", data.mCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_DiamondPurchaseCFG Loaded. Load Data:%u", mMapData.size());
}

void M_DiamondPurchaseCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_DiamondPurchaseCFG* M_DiamondPurchaseCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_DiamondPurchaseCFG());
	}
	return msSingleton.get();
}

void M_DiamondPurchaseCFG::Release()
{
	msSingleton.reset(nullptr);
}
